// FILENAME:	GoP_Fun_with_Scanning.cs
//
// AUTHORS:  	[GoP]~SoMeOnE~TL and pLaGUe-DoG with some help from Riana
//
// RANDOMe THOUGHT: I was bored when making the other maps so I thought of making a fun one
// that could use all those loveable commands :) That wasnt a Random thougth. Just some history.
//------------------------------------------------------------------------------

$missionName = "GoP_Fun_with_Scanning";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;
}

function onMissionLoad(){
   cdAudioCycle("Yougot", "Newtech", "Cyberntx"); 
}

// move the map
$server::HudMapViewOffsetX = -1500;
$server::HudMapViewOffsetY = 2500;

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
	
	temperateSounds();
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

// The drop pods!
function pod::structure::onScan(%scanned, %scanner)
{
   %x1 = getPosition(%scanner, x) + 200;
   %y1 = getPosition(%scanner, y) + 200;
   %z1 = getTerrainHeight(%x1, %y1) + 500;
   %x2 = getPosition(%scanner, x) + 100;
   %y2 = getPosition(%scanner, y) + 100;
   %z2 = getTerrainHeight(%x2, %y2);
   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);   
}
//Even closer Drop pod
function cpod::structure::onScan(%scanned, %scanner)
{
   %x1 = getPosition(%scanner, x) + 200;
   %y1 = getPosition(%scanner, y) + 200;
   %z1 = getTerrainHeight(%x1, %y1) + 500;
   %x2 = getPosition(%scanner, x) + 25;
   %y2 = getPosition(%scanner, y) + 25;
   %z2 = getTerrainHeight(%x2, %y2);
   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);   
}
//Closer Drop pod
function npod::structure::onScan(%scanned, %scanner)
{
   %x1 = getPosition(%scanner, x) + 200;
   %y1 = getPosition(%scanner, y) + 200;
   %z1 = getTerrainHeight(%x1, %y1) + 500;
   %x2 = getPosition(%scanner, x) + 50;
   %y2 = getPosition(%scanner, y) + 50;
   %z2 = getTerrainHeight(%x2, %y2);
   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);   
}
//The 'I dare you to Scan me' command
function boom::structure::onScan(%scanned, %scanner)
{
   damageArea(%scanner, 0, 0, 0, 350, 250000);
}
//This is the teleport Command, you should try it. Fast escape.
function long::structure::onScan(%scanned, %scanner)
{
   setPosition(%scanner, %x + 500, %y + 500, 1000);
}
//Like the teleport command above, only it throws you 10000m in the air.
function high::structure::onScan(%scanned, %scanner)
{
   setPosition(%scanner, %x, %y, 10000);
}
//Scan to hear what I think of you.
function reda::structure::onScan(%scanned, %scanner)
{
   say("%scanner", 1, "You NEED redactive programming!!!", "C6_youneedredact.wav");
}
//Scan to hear what I think of you, again.
function brai::structure::onScan(%scanned, %scanner)
{
    say("%scanner", 1, "Brains sure don't get in your way!", "F4_Tiger_brains.wav");
}
//Scan to hear what I think of you some more.
function idit::structure::onScan(%scanned, %scanner)
{
   say("%scanner", 1, "Try to control that twitch, idiot!", "M12_HMan_trytocon.wav");
}
//Scan to hear what I think of you for another time.
function rook::structure::onScan(%scanned, %scanner)
{
   say("%scanner", 1, "Rookie!", "M5_rookie.wav");
}
//Scan to hear what I think of you for once more.
function eflo::structure::onScan(%scanned, %scanner)
{
    say("%scanner", 1, "Eflodat!", "F2_DM_eflondat.wav");
}
//Scan to hear what I think of you for forever.
function dust::structure::onScan(%scanned, %scanner)
{
    say("%scanner", 1, "Your mother was a duster.", "F2_DM_yourmother.WAV");
}
//Makes ya glow Blue!
function blue::structure::onScan(%scanned, %scanner)
{
   setVehicleSpecialIdentity(%scanner, on, blue);
}
//Become the Glowy red thingie!
function redg::structure::onScan(%scanned, %scanner)
{
   setVehicleSpecialIdentity(%scanner, on, red);
}
// Amaze yer eyes with a sickening yellow glow!
function yell::structure::onScan(%scanned, %scanner)
{
   setVehicleSpecialIdentity(%scanner, on, yellow);
}
// Go out in style with a purplish tutu glow!
function purp::structure::onScan(%scanned, %scanner)
{
   setVehicleSpecialIdentity(%scanner, on, purple);
}
//Clones who ever you scan!!!
function vehicle::onScan(%scanned, %scanner)
{
   %clone = cloneVehicle(%scanned);
   %x = getPosition(%scanned, x) + 100;
   %y = getPosition(%scanned, y) + 100;
   %z = getPosition(%scanned, z) + 100;
   setPosition(%clone, %x, %y, %z);
}
//Fight yer self!!!
function clon::structure::onScan(%scanned, %scanner)
{
   %clone = cloneVehicle(%scanner);
   %x = getPosition(%scanned, x) + 100;
   %y = getPosition(%scanned, y) + 100;
   %z = getPosition(%scanned, z) + 100;
   setPosition(%clone, %x, %y, %z);
}
//Go to your nav Point!
function navp::structure::onScan(%scanned, %scanner)
{
   %nav = getVehicleNavMarkerId(%scanner);
   %x = getPosition(%nav, x);
   %y = getPosition(%nav, y);
   %z = getPosition(%nav, z);
   setPosition(%scanner, %x, %y, %z);
}