// FILENAME:	      GoP_Obstacle.cs
//
// AUTHORS:  	      [GoP]~SoMeOnE~TL and pLaGUe-DoG with some help from [GoP]~Wedge~FHL
//
// RANDOMe THOUGHT:    Who are the Chupie Doll & Youth in Asia?
//------------------------------------------------------------------------------

$missionName = "GoP_Obstacle";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	marsSounds();
}

function onMissionLoad(){
   cdAudioCycle("Yougot", "Newtech"); 
}

// Water Tower splash functionality
function structure::onDestroyed(%this, %attackerId){
	// Which water tower was destroyed?
	if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower1")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash1"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash1"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower2")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash2"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash2"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower3")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash3"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash3"), 0, true);
	}
}

//Guess, just guess what this means?
function vehicle::onDestroyed(%destroyed, %destroyer)
{
     say("Everybody", 1, "BOOM! Somebody go BOOM!", "SFX_FOG.WAV");
}


//Place Victim.. er Player on Blue Team.
function vehicle::onAdd(%vehicleId) 
{
      setTeam(%vehicleId, *IDSTR_TEAM_BLUE);
}

//This makes the mon-u-ment at the end heal you, the pesky ... pesk!
function heod::structure::onScan(%scanned, %scanner)
{
     healObject(%scanner, 50000);
     say("Everybody", 1, "Somebody made it to the end and is healing, the lucky... ...IT.", "SFX_HAD.WAV");
}

//Uhh... Oh yea! This is what IT says when you enter the server. Stupid player.
function player::onAdd(%this)
{
   say(%this, 0, "Ello! Welcome to GoP Obsticle Course v1.0. Go thru the start and evade the Turrent fire, try to make it to the end. Scan the Mon-u-ment at the end for a heal. Good luck. This map was made by the Grand Master Dis Pilot, [GoP]~SoMeOnE~TL. Please visit us on the web at: www.gopstarsiege.cjb.net.");
}
//Sickening.......................................................................................................................................................................^^^^^^I didnt really mean that :::evil grin:::

//This drops a pod where you spawn... Hehehe Cool! Maybe it should do damge, hmm... :::Evil grin:::
function vehicle::onAdd(%vehicleId)
{
   %x1 = getPosition(%vehicleId, x);
   %y1 = getPosition(%vehicleId, y);
   %z1 = getTerrainHeight(%x1, %y1) + 500;
   %x2 = getPosition(%vehicleId, x);
   %y2 = getPosition(%vehicleId, y);
   %z2 = getTerrainHeight(%x2, %y2);
   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);   
}


	//Vehicles
	allowVehicle( all, false);
	allowVehicle(                                           20,  TRUE  );      //Seeker
	allowVehicle(                                           21,  TRUE  );      //Goad
	allowVehicle(                                           22,  TRUE  );      //Shepherd
	allowVehicle(                                           23,  TRUE  );      //Adjudicator
	allowVehicle(                                           24,  TRUE  );      //Executioner
	allowVehicle(                                            4,  TRUE  );      //Terran Talon
	allowVehicle(                                           13,  TRUE  );      //Knight's Talon
	allowVehicle(                                            2,  TRUE  );      //Terran Minotaur
	allowVehicle(                                           11,  TRUE  );      //Knight's Minotaur
	allowVehicle(                                            5,  TRUE  );      //Terran Basilisk
	allowVehicle(                                           14,  TRUE  );      //Knight's Basilisk
	allowVehicle(                                            1,  TRUE  );      //Terran Apocalypse
	allowVehicle(                                           10,  TRUE  );      //Knight's Apocalypse
	allowVehicle(                                           40,  TRUE  );      //Harabec's Apocalypse
	allowVehicle(                                            3,  TRUE  );      //Terran Gorgon
	allowVehicle(                                           12,  TRUE  );      //Knight's Gorgon
	allowVehicle(                                           30,  TRUE  );      //Emancipator
	allowVehicle(                                           33,  TRUE  );      //Olympian
	allowVehicle(                                           52,  TRUE  );      //Pirate Emancipator
	allowVehicle(                                           55,  TRUE  );      //Player Plat Adjudicator
	allowVehicle(                                           56,  TRUE  );      //Player Plat Executioner
	allowVehicle(                                           35,  TRUE  );      //Metagen Seeker
	allowVehicle(                                           36,  TRUE  );      //Metagen Goad
	allowVehicle(                                           37,  TRUE  );      //Metagen Shepherd

	allowVehicle(                                           25,  TRUE  );      //Bolo
	allowVehicle(                                           26,  TRUE  );      //Recluse
	allowVehicle(                                           41,  TRUE  );      //Predator
	allowVehicle(                                           31,  TRUE  );      //Avenger
	allowVehicle(                                           32,  TRUE  );      //Dreadlock
	allowVehicle(                                            8,  TRUE  );      //Disrupter
	allowVehicle(                                            7,  TRUE  );      //Myrmidon
	allowVehicle(                                            6,  TRUE  );      //Paladin
	allowVehicle(                                           17,  TRUE  );      //Knight Disrupter
	allowVehicle(                                           16,  TRUE  );      //Knight Myrmidon
	allowVehicle(                                           15,  TRUE  );      //Knight Paladin
	allowVehicle(                                          138,  TRUE  );
	allowVehicle(                                          150,  TRUE  );

	//weapons
        //I just screwed yer butt! Now all you can do is tickle the Turrents with yer puny
        //EMPs!
	allowWeapon(                                       all,     FALSE  );
	allowWeapon(                                           101,  FALSE );      //Laser
	allowWeapon(                                           102,  FALSE );      //Heavy Laser
	allowWeapon(                                           103,  FALSE );      //Comp Laser
	allowWeapon(                                           104,  FALSE );      //Twin Laser
	allowWeapon(                                           105,  TRUE  );      //Emp
	allowWeapon(                                           106,  FALSE );      //ELF
	allowWeapon(                                           107,  FALSE );      //Blaster
	allowWeapon(                                           108,  FALSE );      //Heavy Blaster
	allowWeapon(                                           109,  FALSE );      //PBW
	allowWeapon(                                           110,  FALSE );      //Plasma
	allowWeapon(                                           111,  FALSE );      //Blink Gun
	allowWeapon(                                           112,  FALSE );      //Qgun
	allowWeapon(                                           113,  FALSE );      //MFAC
	allowWeapon(                                           114,  FALSE );      //Nano Infuser
	allowWeapon(                                           115,  FALSE );      //Nanite Cannon
	allowWeapon(                                           116,  FALSE );      //Autocannon
	allowWeapon(                                           117,  FALSE );      //Hvy Autocannon
	allowWeapon(                                           118,  FALSE );      //EMC Autocannon
	allowWeapon(                                           119,  FALSE );      //Blast Cannon
	allowWeapon(                                           120,  FALSE );      //Hvy Blast Can
	allowWeapon(                                           121,  FALSE );      //Rail Gun
	allowWeapon(                                           124,  FALSE );      //Pit Viper 8
	allowWeapon(                                           125,  FALSE );      //Pit Viper 12
	allowWeapon(                                           126,  FALSE );      //Sparrow 6
	allowWeapon(                                           127,  FALSE );      //Sparrow 10
	allowWeapon(                                           128,  FALSE );      //SWARM 6
	allowWeapon(                                           129,  FALSE );      //Minion
	allowWeapon(                                           130,  FALSE );      //Shrike 8
	allowWeapon(                                           147,  FALSE );      //Aphid
	allowWeapon(                                           131,  FALSE );      //Arachnitron 4
	allowWeapon(                                           132,  FALSE );      //Arachnitron 8
	allowWeapon(                                           133,  FALSE );      //Arachnitron 12
	allowWeapon(                                           134,  FALSE );      //Proximity 6
	allowWeapon(                                           135,  FALSE );      //Proximity 10
	allowWeapon(                                           136,  FALSE );      //Proximity 15
	allowWeapon(                                           142,  FALSE );      //Radiation Gun
	allowWeapon(                                             3,  FALSE );      //Disrupter
	allowWeapon(                                           150,  FALSE );      //SMART Gun

	//Components
	//Reactors
	allowComponent(                                        200,  TRUE  );      //Human Micro Reactor
	allowComponent(                                        201,  TRUE  );      //Small Human Reactor 2 -- small
	allowComponent(                                        202,  TRUE  );      //Medium Human Reactor 1 Standard
	allowComponent(                                        203,  TRUE  );      //Medium Human Reactor 2 medium
	allowComponent(                                        204,  TRUE  );      //Large Human Reactor 1 -- large
	allowComponent(                                        205,  TRUE  );      //Large Human Reactor 2-- Maxim
	allowComponent(                                        225,  TRUE  );      //Small Cybrid Reactor 1 -- Alpha
	allowComponent(                                        226,  TRUE  );      //Small Cybrid Reactor 2-- Beta
	allowComponent(                                        227,  TRUE  );      //Medium Cybrid Reactor 1 -- Gamma
	allowComponent(                                        228,  TRUE  );      //Medium Cybrid Reactor 2--delta
	allowComponent(                                        229,  TRUE  );      //Large Cybrid Reactor 1--epsilon
	allowComponent(                                        230,  TRUE  );      //Large Cybrid Reactor 2--theta
	//Shields
	allowComponent(                                        300,  TRUE  );      //Human Standard Shield
	allowComponent(                                        301,  TRUE  );      //Human Protector Shield
	allowComponent(                                        302,  TRUE  );      //Human Guardian Shield
	allowComponent(                                        303,  TRUE  );      //Human FastCharge Shield
	allowComponent(                                        304,  TRUE  );      //Human Centurian Shield
	allowComponent(                                        305,  TRUE  );      //Human Repulsor Shield
	allowComponent(                                        306,  TRUE  );      //Human Titan Shield
	allowComponent(                                        307,  TRUE  );      //Human Medusa Shield
	allowComponent(                                        326,  TRUE  );      //Cybrid Alpha Shield
	allowComponent(                                        327,  TRUE  );      //Cybrid Beta Shield
	allowComponent(                                        328,  TRUE  );      //Cybrid Gamma Shield
	allowComponent(                                        329,  TRUE  );      //Cybrid Delta Shield
	allowComponent(                                        330,  TRUE  );      //Cybrid Epsilon Shield
	allowComponent(                                        331,  TRUE  );      //Cybrid Zeta Shield
	allowComponent(                                        332,  TRUE  );      //Cybrid Eta Shield
	allowComponent(                                        333,  TRUE  );      //Cybrid Theta Shield

	//Sensors
	allowComponent(                                        400,  TRUE  );      //Basic Human Sensor
	allowComponent(                                        401,  TRUE  );      //Long Range Sensor -- Ranger
	allowComponent(                                        408,  TRUE  );      //Standard Human Sensor
	allowComponent(                                        409,  TRUE  );      //Human Longbow Sensor
	allowComponent(                                        410,  TRUE  );      //Human Infiltrator Sensor
	allowComponent(                                        411,  TRUE  );      //Human Crossbow Sensor
	allowComponent(                                        412,  TRUE  );      //Human Ultralight Sensor
	allowComponent(                                        413,  TRUE  );      //Human Hound Dog Sensor
	allowComponent(                                        414,  TRUE  );      //Thermal Sensor
	allowComponent(                                        426,  TRUE  );      //Basic Cybrid Sensor (Alpha)
	allowComponent(                                        427,  TRUE  );      //Long Range Cybrid Sensor (Beta)
	allowComponent(                                        428,  TRUE  );      //Standard Cybrid Sensor (Gamma)
	allowComponent(                                        429,  TRUE  );      //Cybrid Longbow Sensor (Delta)
	allowComponent(                                        430,  TRUE  );      //Cybrid Infiltrator Sensor (Epsilon)
	allowComponent(                                        431,  TRUE  );      //Cybrid Crossbow Sensor (Zeta)
	allowComponent(                                        432,  TRUE  );      //Cybrid Ultralight Sensor (Eta)
	allowComponent(                                        433,  TRUE  );      //Cybrid Hound Dog Sensor (Theta)
	allowComponent(                                        434,  TRUE  );      //Motion Detector (Iota)

	//Engines
	allowComponent(                                        100,  TRUE  );      //Human Light Vehicle Engine
	allowComponent(                                        101,  TRUE  );      //Human High Output Light Engine
	allowComponent(                                        102,  TRUE  );      //Human Agile Light Engine
	allowComponent(                                        103,  TRUE  );      //Human Standard Medium Engine
	allowComponent(                                        104,  TRUE  );      //Human High Output Medium Engine
	allowComponent(                                        105,  TRUE  );      //Human Medium Agility Engine
	allowComponent(                                        106,  TRUE  );      //Human Standard Heavy Engine
	allowComponent(                                        107,  TRUE  );      //Human Improved Heavy Engine
	allowComponent(                                        108,  TRUE  );      //Human Heavy Cruise Engine
	allowComponent(                                        109,  TRUE  );      //Human High Output Heavy Engine
	allowComponent(                                        110,  TRUE  );      //Human Agile Heavy Engine
	allowComponent(                                        111,  TRUE  );      //Human Standard Assault Engine
	allowComponent(                                        112,  TRUE  );      //Human Improved Assault Engine
	allowComponent(                                        113,  TRUE  );      //Human heavy turbine engine
	allowComponent(                                        114,  TRUE  );      //High Output Turbine (HOT)
	allowComponent(                                        115,  TRUE  );      //Human super heavy engine
	allowComponent(                                        128,  TRUE  );      //Cybrid Alpha Light Vehicle Engine
	allowComponent(                                        129,  TRUE  );      //Cybrid Beta Light Agility Engine
	allowComponent(                                        130,  TRUE  );      //Cybrid Gamma Standard Medium Engine
	allowComponent(                                        131,  TRUE  );      //Cybrid Delta Medium Cruise Engine
	allowComponent(                                        132,  TRUE  );      //Cybrid Epsilon Improved Medium Engine
	allowComponent(                                        133,  TRUE  );      //Cybrid Zeta Medium High Output Engine
	allowComponent(                                        134,  TRUE  );      //Cybrid Eta Medium Agility Engine
	allowComponent(                                        135,  TRUE  );      //Cybrid Theta Standard Heavy Engine
	allowComponent(                                        136,  TRUE  );      //Cybrid Iota Heavy High Output Engine
	allowComponent(                                        137,  TRUE  );      //Cybrid Kappa Heavy Agility Engine
	allowComponent(                                        138,  TRUE  );      //Cybrid Lamda Standard Assault Engine
	allowComponent(                                        139,  TRUE  );      //Cybrid Mu Improved Assault Engine
	allowComponent(                                        140,  TRUE  );      //Cybrid Nu High Output Assault Engine
	allowComponent(                                        141,  TRUE  );      //Cybrid Xi Heavy Assault Engine
	allowComponent(                                        142,  TRUE  );      //Cybrid Omicron Heavy Assault Turbine
	allowComponent(                                        143,  TRUE  );      //Cybrid Pi Super Heavy Turbine

	//Armor
	allowComponent(                                        926,  FALSE );      //Carbon Fiber (CARLAM)
	allowComponent(                                        927,  TRUE  );      //Quad Bonded Metaplas (QBM)
	allowComponent(                                        928,  TRUE  );      //DURAC (Depleteted Uranium)
	allowComponent(                                        929,  TRUE  );      //Ceramic
	allowComponent(                                        930,  TRUE  );      //Crystaluminum
	allowComponent(                                        931,  TRUE  );      //Quicksilver

	//Internal Components
	//Even worse! :::evil grin::: I took away your precious Cloaks! Now you will have to go
        //into the maze with EMPs and no Cloaks, Ha-Ha! I was even thinkin of banning CARLAM 
        //armor, but then I said 'Nah! Those Turrents are smart enuf to find the victims'
        //Heheheheheheahahahahahahahahahohohohohohohohohohho!!! Or maybe they aint.
        allowComponent(                                        800,  TRUE  );      //Human Basic Computer
	allowComponent(                                        801,  TRUE  );      //Human Improved Computer
	allowComponent(                                        802,  TRUE  );      //Human Advanced Computer
	allowComponent(                                        805,  TRUE  );      //Cybrid Basic Systems Control
	allowComponent(                                        806,  TRUE  );      //Cybrid Enhanced Systems Control
	allowComponent(                                        807,  TRUE  );      //Cybrid Advanced Systems Control
	allowComponent(                                        810,  TRUE  );      //Guardian ECM
	allowComponent(                                        811,  TRUE  );      //Doppleganger ECM
	allowComponent(                                        812,  TRUE  );      //Cybrid Alpha ECM
	allowComponent(                                        813,  TRUE  );      //Cybrid Beta ECM
	allowComponent(                                        820,  TRUE  );      //Thermal Diffuser
	allowComponent(                                        830,  FALSE );      //Chameleon
	allowComponent(                                        831,  FALSE );      //Cuttlefish cloak
	allowComponent(                                        840,  TRUE  );      //Shield Modulator
	allowComponent(                                        845,  TRUE  );      //Shield Capacitor
	allowComponent(                                        850,  TRUE  );      //Shield Amplifier (increases shield constant)
	allowComponent(                                        860,  TRUE  );      //Laser Targeting Module
	allowComponent(                                        865,  TRUE  );      //Extra Battery
	allowComponent(                                        870,  TRUE  );      //Reactor Capacitor
	allowComponent(                                        875,  TRUE  );      //Field Stabilizer
	allowComponent(                                        880,  TRUE  );      //Rocket Booster
	allowComponent(                                        885,  TRUE  );      //Turbine Boost
	allowComponent(                                        890,  TRUE  );      //NanoRepair
	allowComponent(                                        900,  TRUE  );      //Angle Life Support
	allowComponent(                                        910,  TRUE  );      //Agrav Generator
	allowComponent(                                        912,  TRUE  );      //ElectroHull
	allowComponent(                                        914,  TRUE  );      //UAP


